// Menu items
var menuItem1 = null;
var menuItem2 = null;

// Menu id's
var CMD_MENU_ITEM1 = 10;
var CMD_MENU_ITEM2 = 11;

var serviceObj = null;

window.onload = init;

// Initializes the widget
function init() {
    createMenu();
}

// Creates the main menu
function createMenu() {
    // Create the first menu item
    menuItem1 = new MenuItem("Execute snippet", CMD_MENU_ITEM1);
    menuItem1.onSelect = onMenuItemSelected;
    window.menu.append(menuItem1);
    
    // Create the second menu item
    menuItem2 = new MenuItem("Command stub", CMD_MENU_ITEM2);
    menuItem2.onSelect = onMenuItemSelected;
    window.menu.append(menuItem2);
}

// Gets called when a menu item is selected
function onMenuItemSelected(menuId) {
    switch (menuId) {
        case CMD_MENU_ITEM1:
            executeSnippet();
            break;
        case CMD_MENU_ITEM2:
            // TODO: Write the implementation
            break;
    }
}

function executeSnippet() {
    // Obtain the AppManager service object
    try {
        serviceObj = device.getServiceObject("Service.AppManager", "IAppManager");
    } catch (ex) {
        alert("Service object cannot be found.");
        return;
    }
 
    // We are interested in applications, so let's define the criteria
    // respectively
    var criteria = new Object();
    criteria.Type = "Application";
 
    // Obtain the list of installed applications
    var result = serviceObj.IAppManager.GetList(criteria);
    var appList = createAppList(result.ReturnValue);
    
    // Display the list
    appList.sort();
    for (var i = 0; i < appList.length; i++) {
        printString(appList[i]);
    }
}

// Creates the list of installed applications
function createAppList(iterator) {
    var list = new Array();
    try {
        iterator.reset();
        var item;
        while ((item = iterator.getNext()) != undefined) {
            var txt = "";
            txt += item.Caption + " (";
            txt += item.Uid + ")";
            list.push(txt);
        }
    } catch (ex) {
        alert(ex);
    }
    return list;
}
 
// Prompts the user for text
function queryText() {
    text = prompt("Enter text:", "");
    // If the user cancelled, return null
    if (text == null || text.trim().length == 0) {
        return null;
    } else {
        return text;
    }
}

// Appends a paragraph of text on the screen
function printString(text) {
    var bodyContentElement = document.getElementById("bodyContent");
    var paragraphElement = document.createElement("p");
    var textElement = document.createTextNode(text);
    paragraphElement.appendChild(textElement);
    bodyContentElement.appendChild(paragraphElement);
}
